searchData={"items":[{"type":"module","title":"ReqEmbed","doc":"[oEmbed](https://oembed.com) plugin for [Req](https://hex.pm/packages/req).\n\nSupports [discovery](https://oembed.com/#section4) and 300+ [providers](https://github.com/BeaconCMS/req_embed/blob/main/priv/providers.json).","ref":"ReqEmbed.html"},{"type":"module","title":"Installation - ReqEmbed","doc":"Add `:req_embed` dependency:\n\n```elixir\ndef deps do\n  [\n    {:req_embed, \"~> 0.2\"}\n  ]\nend\n```\n\nOr use [Igniter](https://hexdocs.pm/igniter):\n\n```sh\nmix igniter.install req_embed\n```","ref":"ReqEmbed.html#module-installation"},{"type":"module","title":"Usage - ReqEmbed","doc":"","ref":"ReqEmbed.html#module-usage"},{"type":"module","title":"Req plugin - ReqEmbed","doc":"```elixir\nreq = Req.new() |> ReqEmbed.attach()\n\nReq.get!(req, url: \"https://www.youtube.com/watch?v=XfELJU1mRMg\").body\n#=>\n# %ReqEmbed.Video{\n#   type: \"video\",\n#   version: \"1.0\",\n#   title: \"Rick Astley - Never Gonna Give You Up (Official Music Video)\",\n#   author_name: \"Supirorguy508\",\n#   author_url: \"https://www.youtube.com/@supirorguy5086\",\n#   provider_name: \"YouTube\",\n#   provider_url: \"https://www.youtube.com/\",\n#   cache_age: nil,\n#   thumbnail_url: \"https://i.ytimg.com/vi/XfELJU1mRMg/hqdefault.jpg\",\n#   thumbnail_width: 480,\n#   thumbnail_height: 360,\n#   html: \"  \",\n#   width: 200,\n#   height: 113\n# }\n```\n\nWhen successful, the response body will contain either one of the following structs representing the oEmbed type:\n\n  - `ReqEmbed.Link`\n  - `ReqEmbed.Photo`\n  - `ReqEmbed.Rich`\n  - `ReqEmbed.Video`","ref":"ReqEmbed.html#module-req-plugin"},{"type":"module","title":"Phoenix Component - ReqEmbed","doc":"Use [ReqEmbed.embed/1](https://hexdocs.pm/req_embed/ReqEmbed.html#req_embed/1) to display oEmbed content in HEEx templates:\n\n```heex\n \n```\n\nRenders:\n\n```html\n  \n```\n\nNote that `:phoenix_live_view` is required to use the component, it's not a direct dependency.","ref":"ReqEmbed.html#module-phoenix-component"},{"type":"module","title":"Raw HTML - ReqEmbed","doc":"Or alternatively use [ReqEmbed.html/2](https://hexdocs.pm/req_embed/ReqEmbed.html#html/2) to get the oEmbed content as HTML:\n\n```elixir\nReqEmbed.html(\"https://www.youtube.com/watch?v=XfELJU1mRMg\")\n#   \n```\n\nWrap it in a `{:safe, html}` tuple or call `Phoenix.HTML.raw/1` to render it in Phoenix templates.","ref":"ReqEmbed.html#module-raw-html"},{"type":"function","title":"ReqEmbed.attach/2","doc":"Attach the oEmbed plugin into Req.","ref":"ReqEmbed.html#attach/2"},{"type":"function","title":"Options - ReqEmbed.attach/2","doc":"* `:query` (`t:map/0`) - Defaults to `%{}`. The query parameters to be sent to the oEmbed endpoint,\n    like `:maxwidth`, `:maxheight`, and others supported by the provider.\n    The parameters `:url` and `:format` are managed by the plugin, you can't override them.\n    See section [2.2 Consumer Request](https://oembed.com/#section2) for more info.\n\n  * `:discover` (`t:boolean/0`) - Defaults to `true`. When enabled, it will first attempt to auto-discover\n    the oEmbed endpoint by looking for the link tag in the HTML response. If no link tag is found, it will\n    fallback to searching for a known provider endpoint. When disabled, it will skip the HTML parsing step\n    and only use the known provider endpoints.","ref":"ReqEmbed.html#attach/2-options"},{"type":"function","title":"Examples - ReqEmbed.attach/2","doc":"iex> req = Req.new() |> ReqEmbed.attach()\n    iex> Req.get!(req, url: \"https://x.com/ThinkingElixir/status/1848702455313318251\").body\n    iex> %ReqEmbed.Rich{\n           type: \"rich\",\n           version: \"1.0\",\n           author_name: \"ThinkingElixir\",\n           author_url: \"https://twitter.com/ThinkingElixir\",\n           html: \"  News includes upcoming Elixir v1.18 ...\n           ...\n         }","ref":"ReqEmbed.html#attach/2-examples"},{"type":"function","title":"ReqEmbed.embed/1","doc":"Phoenix Component to render oEmbed content.\n\nRequires [phoenix_live_view](https://hex.pm/packages/phoenix_live_view) to be installed,\notherwise you can use `html/2` directly.\n\nThis component is essentially a wrapper for `html/2`.","ref":"ReqEmbed.html#embed/1"},{"type":"function","title":"Example - ReqEmbed.embed/1","doc":"def render(assigns) do\n      ~H\"\"\"\n      <%= ReqEmbed.embed(url: \"https://www.youtube.com/watch?v=XfELJU1mRMg\") %>\n      \"\"\"\n    end","ref":"ReqEmbed.html#embed/1-example"},{"type":"function","title":"Attributes - ReqEmbed.embed/1","doc":"* `url` (`:string`) (required) - URL of the resource to be embedded.\n* `class` (`:string`) - CSS class to be added into the   tag, if used it removes both width and height attributes.\n* `include_caption` (`:boolean`) - When enabled, it will include the photo title in  . Defaults to `true`.","ref":"ReqEmbed.html#embed/1-attributes"},{"type":"function","title":"ReqEmbed.html/2","doc":"Render the oEmbed content as HTML.","ref":"ReqEmbed.html#html/2"},{"type":"function","title":"Options - ReqEmbed.html/2","doc":"* `:class` (`t:String.t/0`) - Defaults to `nil`. CSS class to be added into the   tag, if used it removes both `width` and `height` attributes.\n  * `:include_caption` (`t:boolean/0`) - Defaults to `true`. When enabled, it will include the photo title in ` `.","ref":"ReqEmbed.html#html/2-options"},{"type":"function","title":"Examples - ReqEmbed.html/2","doc":"iex> ReqEmbed.html(\"https://www.youtube.com/watch?v=XfELJU1mRMg\")\n      \n\nReplace the `width` and `height` attributes with a CSS class:\n\n    iex> ReqEmbed.html(\"https://www.youtube.com/watch?v=XfELJU1mRMg\", class: \"aspect-video\")\n      \n\nWrap it in a `{:safe, html}` tuple or call `Phoenix.HTML.raw/1` to render it in Phoenix templates.","ref":"ReqEmbed.html#html/2-examples"},{"type":"module","title":"ReqEmbed.Link","doc":"Generic embed data type.\n\nThe simplest type that allows a provider to return any generic embed data without providing\neither the url or html parameters.\n\nSpec: [2.3.4.3. The link type](https://oembed.com/#section2)\n\nThese are the common fields that all oEmbed response types may include:\n\n* `type` (required) - The resource type. Valid values are: photo, video, link, rich\n* `version` (required) - The oEmbed version number. Must be \"1.0\"\n* `title` (optional) - A text title describing the resource\n* `author_name` (optional) - The name of the author/owner of the resource\n* `author_url` (optional) - A URL for the author/owner of the resource\n* `provider_name` (optional) - The name of the resource provider\n* `provider_url` (optional) - The url of the resource provider\n* `cache_age` (optional) - The suggested cache lifetime for this resource, in seconds\n* `thumbnail_url` (optional) - A URL to a thumbnail image representing the resource\n* `thumbnail_width` (optional) - The width of the optional thumbnail\n* `thumbnail_height` (optional) - The height of the optional thumbnail","ref":"ReqEmbed.Link.html"},{"type":"module","title":"ReqEmbed.Photo","doc":"The photo type used to represent static photos.\n\nSpec: [2.3.4.1. The photo type](https://oembed.com/#section2)\n\nIncludes all base `ReqEmbed.Link` fields plus:\n\n* `url` (required) - The source URL of the image. Consumers should be able to insert this URL into an   element. Only HTTP and HTTPS URLs are valid\n* `width` (required) - The width in pixels of the image specified in the url parameter\n* `height` (required) - The height in pixels of the image specified in the url parameter","ref":"ReqEmbed.Photo.html"},{"type":"module","title":"ReqEmbed.Rich","doc":"The rich type used for rich HTML content that does not fall under one of the other categories.\n\nSpec: [2.3.4.4. The rick type](https://oembed.com/#section2)\n\nIncludes all base `ReqEmbed.Link` fields plus:\n\n* `html` (required) - The HTML required to display the resource. The HTML should have no padding or margins.\n  The markup should be valid XHTML 1.0 Basic\n* `width` (required) - The width in pixels required to display the HTML\n* `height` (required) - The height in pixels required to display the HTML","ref":"ReqEmbed.Rich.html"},{"type":"module","title":"ReqEmbed.Video","doc":"The video type used to represent playable videos.\n\nSpec: [2.3.4.2. The video type](https://oembed.com/#section2)\n\nIncludes all base `ReqEmbed.Link` fields plus:\n\n* `html` (required) - The HTML required to embed a video player. The HTML should have no padding or margins\n* `width` (required) - The width in pixels required to display the HTML\n* `height` (required) - The height in pixels required to display the HTML","ref":"ReqEmbed.Video.html"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"0.2.1 (2025-03-19) - Changelog","doc":"","ref":"changelog.html#0-2-1-2025-03-19"},{"type":"extras","title":"Changed - Changelog","doc":"* Repo link","ref":"changelog.html#changed"},{"type":"extras","title":"0.2.0 (2025-03-19) - Changelog","doc":"","ref":"changelog.html#0-2-0-2025-03-19"},{"type":"extras","title":"Changed - Changelog","doc":"* Added `html/2` to display oEmbed content as raw html\n  * Added `embed/1` Phoenix component to display oEmbed content in HEEx templates","ref":"changelog.html#changed"},{"type":"extras","title":"0.1.2 (2025-03-13) - Changelog","doc":"","ref":"changelog.html#0-1-2-2025-03-13"},{"type":"extras","title":"Changed - Changelog","doc":"* Removed `ReqEmbed.Content` in favor of `ReqEmbed.Link`","ref":"changelog.html#changed"},{"type":"extras","title":"0.1.1 (2025-03-12) - Changelog","doc":"","ref":"changelog.html#0-1-1-2025-03-12"},{"type":"extras","title":"Added - Changelog","doc":"* Option `:discover` to turn discovery on/off","ref":"changelog.html#added"},{"type":"extras","title":"0.1.0 (2025-03-12) - Changelog","doc":"* Initial release","ref":"changelog.html#0-1-0-2025-03-12"}],"content_type":"text/markdown","proglang":"elixir","producer":{"name":"ex_doc","version":"0.37.3"}}